<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Release process | Eclipse ESCET™ development documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-dev.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-dev.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">Eclipse ESCET™ website</a></p>
    <div id="toctitle">
     Eclipse ESCET™ development documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../index.html">Home</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#eclipse-escet-development">Eclipse ESCET development</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="dev-list.html">The Eclipse ESCET dev-list</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="development-process.html">Development process</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#issue-tracking">Issue tracking</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#releases-and-milestones">Releases and milestones</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#working-on-issues">Working on issues</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#working-with-branches">Working with branches</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#commits">Commits</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="development-process.html#merge-requests">Merge requests</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="development-process.html#collaborating-with-contributors-on-a-merge-request">Collaborating with contributors on a merge request</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="development-process.html#simple-approach">Simple approach</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="development-process.html#advanced-approach">Advanced approach</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="development-process.html#fork-collaboration-script-support">Fork collaboration script support</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="contributing.html">Contributing</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="contributing.html#how-to-contribute-to-eclipse-escet">How to contribute to Eclipse ESCET</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="contributing.html#keeping-in-sync-with-the-official-eclipse-escet-gitlab-repository">Keeping in sync with the official Eclipse ESCET GitLab repository</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="contributing.html#how-to-become-a-committer">How to become a committer</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="issue-tracking.html">Issue tracking</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="dev-env-setup.html">Development environment setup</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="git-repo.html">Git repositories</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="git-repo.html#repository-structure">Repository structure</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="git-repo.html#language-directories">Language directories</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="git-repo.html#middle-layer-common-functionality">Middle layer common functionality</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="coding-standards.html">Coding standards</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="building-and-testing.html">Building and testing</a></li>
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Release process</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#release-policy">Release policy</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#release-retention-policy">Release retention policy</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#planning-for-a-next-version">Planning for a next version</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#preparing-git-repository-for-a-next-version">Preparing Git repository for a next version</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#working-on-a-release">Working on a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#preparing-a-release">Preparing a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#preparing-a-progress-review">Preparing a progress review</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#performing-a-release">Performing a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#removing-archiving-old-releases">Removing/archiving old releases</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="third-party-tools.html">Third party tools</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="dependency-upgrades.html">Dependency upgrades</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="dependency-upgrades.html#eclipse-platform-ide-upgrades">Eclipse Platform/IDE upgrades</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="dependency-upgrades.html#tycho-upgrades">Tycho upgrades</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="dependency-upgrades.html#java-upgrades">Java upgrades</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="license-year-update.html">License year update</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/index.html">Application framework</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/introduction.html">Introduction</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/standalone-vs-eclipse.html">Stand-alone execution versus Eclipse IDE</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-static-information">Application static information</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-options">Application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#stdin-stdout-and-stderr">Stdin, stdout, and stderr</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#graphical-user-interfaces-guis-and-swt">Graphical User Interfaces (GUIs) and SWT</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-termination">Application termination</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#sigint">SIGINT</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#exceptions">Exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#system-properties">System properties</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#file-paths-and-current-working-directory">File paths and current working directory</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/application-class.html">The Application class</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/exception-framework.html">The exception framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#end-user-exceptions">End-user exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#internal-exceptions">Internal exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#chained-exceptions">Chained exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#development-mode">Development mode</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/exit-codes.html">Exit codes</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/io-framework.html">The I/O framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#output-components">Output components</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#output-provider">Output provider</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#stdout-and-stderr">Stdout and stderr</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#stdin">Stdin</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#buffering-and-flushing">Buffering and flushing</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/option-framework.html">The option framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#the-option-class">The option class</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#command-line-options-and-the-option-dialog">Command line options and the option dialog</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#option-categories">Option categories</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#instantiating-options">Instantiating options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#getting-and-setting-option-values">Getting and setting option values</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#option-processing-order">Option processing order</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#command-line-option-syntax">Command line option syntax</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#implementing-your-own-options">Implementing your own options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#standard-options">Standard options</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/compiler-framework.html">The compiler framework</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/implement-your-application.html">How to implement your own application</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/implement-your-application.html#the-runinternal-method">The runInternal method</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/registration.html">Application registration</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#multi-threaded-applications">Multi-threaded applications</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#unit-tests">Unit tests</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#running-an-application-from-another-application">Running an application from another application</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/execution.html">Execution</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../dsm/index.html">Design Structure Matrix (DSM) library</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/entrypoint.html">Code organization</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/algorithm.html">Algorithm and code</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/busdetection.html">Bus detection algorithms</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/references.html">References</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../multivalue/index.html">Multi-value Decision Diagrams library</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/goals.html">Goals</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/variables-and-relations.html">Variables and relations</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/combining-relations.html">Combining relations</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/computing.html">Computing</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../multivalue/practical-usage.html">Practical usage</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../multivalue/practical-usage.html#variables">Variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../multivalue/practical-usage.html#trees-and-relations">Trees and relations</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/index.html">Rail diagram generator</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../rail/introduction.html">Introduction</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/examples.html">Examples</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#diagrams-and-sequences">Diagrams and sequences</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#choices">Choices</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#optional">Optional</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#repetition">Repetition</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#splitting-long-sequences">Splitting long sequences</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#referencing-a-path-in-the-diagram">Referencing a path in the diagram</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#terminals">Terminals</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#meta-terminals">Meta-terminals</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#further-reading">Further reading</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/customizing-output.html">Customizing output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#syntax-of-the-properties-file">Syntax of the properties file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#kinds-of-values">Kinds of values</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#global-settings">Global settings</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#diagram-settings">Diagram settings</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#empty-node">Empty node</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#branch-label">Branch label</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/customizing-output.html#name-node">Name node</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#terminal-text-and-box-properties">Terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#meta-terminal-text-and-box-properties">Meta-terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#non-terminal-text-and-box-properties">Non-terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#token-text-translations">Token text translations</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#sequence">Sequence</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#choice">Choice</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#repetition">Repetition</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/customizing-output.html#debugging-properties">Debugging properties</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#hierarchy">Hierarchy</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#constraint-solving">Constraint solving</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#coordinates">Coordinates</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#default-property-values">Default property values</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../rail/commandline.html">Command-line arguments</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/lexical-syntax.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/lexical-syntax.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/lexical-syntax.html#comments">Comments</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/lexical-syntax.html#terminals">Terminals</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../rail/grammar.html">Grammar</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/debugging.html">Debugging</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/debugging.html#global-internal-structure-of-the-generator">Global internal structure of the generator</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/debugging.html#analyzing-output">Analyzing output</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../setext/index.html">SeText scanner/parser generator</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/lexical-syntax.html">SeText lexical syntax</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/specifying-lexical-syntax.html">Specifying lexical syntax using SeText</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/regular-expressions.html">Regular expressions</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/terminal-descriptions.html">Terminal descriptions</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/imports.html">Imports</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/scanner-hooks.html">Scanner hooks</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/specifying-grammars.html">Specifying grammars using SeText</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/parser-hooks.html">Parser hooks</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/usage-hints.html">Usage hints</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/generated-scanners-parsers.html">Generated scanners/parsers</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/using-in-an-eclipse-plugin-project.html">Using SeText in an Eclipse Plug-in Project</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/limitations.html">Limitations</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../index.html">Eclipse ESCET™ development documentation</a> &gt; <a class="breadcrumb" href="../index.html#eclipse-escet-development">Eclipse ESCET development</a> &gt; <span class="breadcrumb">Release process</span>
   </div>
   <h2 id="release-process"><a class="anchor" href="#"></a>Release process</h2>
   <div class="paragraph">
    <p>This page explains policies related to releases in the Eclipse ESCET project, as well as step by step instructions for the various processes involved with releases, from preparing for a release to actually releasing it.</p>
   </div>
   <div class="paragraph">
    <p>Policies:</p>
   </div>
   <div class="ulist">
    <ul>
     <li>
      <p><a href="#release-policy">Release policy</a></p></li>
     <li>
      <p><a href="#release-retention-policy">Release retention policy</a></p></li>
    </ul>
   </div>
   <div class="paragraph">
    <p>Step by step instructions:</p>
   </div>
   <div class="ulist">
    <ul>
     <li>
      <p><a href="#planning-for-a-next-version">Planning for a next version</a></p></li>
     <li>
      <p><a href="#preparing-git-repository-for-a-next-version">Preparing Git repository for a next version</a></p></li>
     <li>
      <p><a href="#working-on-a-release">Working on a release</a></p></li>
     <li>
      <p><a href="#preparing-a-release">Preparing a release</a></p></li>
     <li>
      <p><a href="#preparing-a-progress-review">Preparing a progress review</a></p></li>
     <li>
      <p><a href="#performing-a-release">Performing a release</a></p></li>
     <li>
      <p><a href="#removing-archiving-old-releases">Removing/archiving old releases</a></p></li>
    </ul>
   </div>
   <div class="sect3">
    <h3 id="release-policy"><a class="anchor" href="#release-policy"></a>Release policy</h3>
    <div class="paragraph">
     <p>The Eclipse ESCET project uses a time-based release policy. We generally release every three months, at the end of each quarter, typically on its last working day.</p>
    </div>
    <div class="paragraph">
     <p>We may however deviate from this. For instance, we may release earlier at the end of the year, well before the Christmas period.</p>
    </div>
    <div class="paragraph">
     <p>Eclipse ESCET has several types of releases:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><strong>Nightlies</strong>: This involves regular releases of new developments. Strictly speaking, these are not nightlies, as they are not released every night, but instead whenever a new change is merged into the <code>develop</code> branch of ESCET’s main <a href="git-repo.html">Git repository</a>.</p></li>
      <li>
       <p><strong>Milestones</strong>: This involves intermediate releases of the current development progress, typically released around halfway a release cycle. For instance, <code>v1.0-M1</code> is the first milestone release for version <code>1.0</code>.</p></li>
      <li>
       <p><strong>Release candidates</strong>: This involves previews that are used for testing prior to a final release. If all is well, the final release is then functionally identical to the release candidate. For instance, <code>v1.0-RC1</code> is the first release candidate for version <code>1.0</code>.</p></li>
      <li>
       <p><strong>Final releases</strong>: This involves a final release for a version of the ESCET toolkit. For instance, <code>v1.0</code> is the final release for version <code>1.0</code>.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="release-retention-policy"><a class="anchor" href="#release-retention-policy"></a>Release retention policy</h3>
    <div class="paragraph">
     <p>The Eclipse ESCET project has the following retention policies for its different types of releases:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><strong>Nightlies</strong>: Each nightly releases is overwritten by the next nightly release. Only the most recent nightly release is thus available.</p></li>
      <li>
       <p><strong>Milestones</strong>: Milestone releases are removed when the final release of the next version is released. Therefore, directly after a final release, only the milestone releases of that version are available. During a release cycle, the milestone releases of the in-progress release and the previous release are available. For instance, when <code>v2.0</code> is released, milestone releases <code>v1.0-M1</code>, <code>v1.0-M2</code>, and so on, will be removed.</p></li>
      <li>
       <p><strong>Release candidates</strong>: Release candidates are removed when the final release of the next version is released. Therefore, directly after a final release, only the release candidates of that version are available. During a release cycle, the release candidates of the in-progress release and the previous release are available. For instance, when <code>v2.0</code> is released, release candidates <code>v1.0-RC1</code>, <code>v1.0-RC2</code>, and so on, will be removed.</p></li>
      <li>
       <p><strong>Final releases</strong>: Final releases are kept indefinitely.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="planning-for-a-next-version"><a class="anchor" href="#planning-for-a-next-version"></a>Planning for a next version</h3>
    <div class="paragraph">
     <p>For a new version (not milestone or release candidate), follow these steps. Perform them well in advance of starting work on the version, i.e. while still working on the previous version:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Create a new release record:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Go to <a href="https://projects.eclipse.org/projects/technology.escet" class="bare">https://projects.eclipse.org/projects/technology.escet</a>.</p></li>
         <li>
          <p>Log in with your Eclipse Foundation account using the link at the top-right of the page.</p></li>
         <li>
          <p>Click the <em>Create a new release</em> link in the bar at the right.</p></li>
         <li>
          <p>Set the planned release date and give the release a name, e.g. <code>0.1</code>, <code>0.1.1</code> or <code>1.0</code>.</p></li>
         <li>
          <p>Click <em>Create and edit</em>.</p></li>
         <li>
          <p>For <em>Description</em>, click the <em>Source</em> button in the toolbar of the editor. Then enter <code>&lt;p&gt;See &lt;a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/milestones/NNN"&gt;Eclipse ESCET GitLab vN.N issues&lt;/a&gt; for more information.&lt;/p&gt;</code>. Replace <code>NNN</code> by the actual GitLab milestone number to ensure a correct URL. Replace <code>vN.N</code> by the version, e.g. <code>v0.1</code>, <code>v0.1.1</code> or <code>v1.0</code>.</p></li>
         <li>
          <p>Change the <em>Release type</em> if applicable.</p></li>
         <li>
          <p>Click <em>Save</em>.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Create a GitLab milestone:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Go to <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/milestones" class="bare">https://gitlab.eclipse.org/eclipse/escet/escet/-/milestones</a>.</p></li>
         <li>
          <p>Sign in with your Eclipse Foundation account using the link at the top-right of the page.</p></li>
         <li>
          <p>Click <em>New milestone</em>.</p></li>
         <li>
          <p>For <em>Title</em> enter the version, e.g. <code>v0.1</code>, <code>v0.1.1</code> or <code>v1.0</code>.</p></li>
         <li>
          <p>For <em>Description</em> enter <code>See also <a href="https://projects.eclipse.org/projects/technology.escet/releases/N.N" class="bare">https://projects.eclipse.org/projects/technology.escet/releases/N.N</a>.</code>. Replace <code>N.N</code> by the actual release record version, e.g. <code>0.1</code>, <code>0.1.1</code> or <code>1.0</code>.</p></li>
         <li>
          <p>For <em>Start date</em> select the first day after the <em>Due date</em> of the previous version.</p></li>
         <li>
          <p>For <em>End date</em> select the same date as the planned release date of the release record.</p></li>
         <li>
          <p>Click <em>Create milestone</em>.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Create release issues:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Go to <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/issues" class="bare">https://gitlab.eclipse.org/eclipse/escet/escet/-/issues</a>.</p></li>
         <li>
          <p>Sign in with your Eclipse Foundation account using the link at the top-right of the page.</p></li>
         <li>
          <p>Click <em>New issue</em>.</p></li>
         <li>
          <p>For <em>Title</em> enter <code>Release vN.N-M1</code>. Replace <code>N.N</code> by the actual release record version, e.g. <code>0.1</code>, <code>0.1.1</code> or <code>1.0</code>.</p></li>
         <li>
          <p>For <em>Milestone</em> select the just created GitLab milestone.</p></li>
         <li>
          <p>For <em>Labels</em> select <em>RelEng/DevOps</em> and <em>Type::Enhancement</em>.</p></li>
         <li>
          <p>Click <em>Create issue</em>.</p></li>
         <li>
          <p>Repeat these steps to create issues for the release candidate (<code>Release vN.N-RC1</code>) and final release (<code>Release vN.N</code>).</p></li>
         <li>
          <p>Repeat these steps to create an issue for <a href="#preparing-git-repository-for-a-next-version">preparing the Git repository for development</a> of the new version (<code>Prepare Git repo for vN.N development</code>).</p></li>
         <li>
          <p>If a <a href="#preparing-a-progress-review">progress review</a> is needed, schedule one if one is not yet scheduled.</p></li>
        </ul>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="preparing-git-repository-for-a-next-version"><a class="anchor" href="#preparing-git-repository-for-a-next-version"></a>Preparing Git repository for a next version</h3>
    <div class="paragraph">
     <p>To prepare the Git repository for the next version (not a milestone or release candidate), follow these steps:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Run in the root of the Git repository the command <code>mvn org.eclipse.tycho:tycho-versions-plugin:N.N.N:set-parent-version -DnewParentVersion=&lt;new-version&gt;</code>, where <code>&lt;new-version&gt;</code> is replaced by the new version (e.g. <code>0.2.0.qualifier</code>), and <code>N.N.N</code> by the Tycho version (e.g., <code>4.0.1</code>, see <code>.mvn/extensions.xml</code> for the version currently in use). This replaces most version numbers automatically. Check all changes to ensure no versions are updated that should not be updated.</p></li>
      <li>
       <p>Verify that the <code>product</code> <code>version</code> in <code>org.eclipse.escet.product/escet.product</code> is properly updated. The old version should no longer be present. This should be automatic.</p></li>
      <li>
       <p>Verify that the <code>feature</code> <code>version</code> of the product feature in <code>org.eclipse.escet.product/escet.product</code> is properly updated. The old version should no longer be present. This should be automatic.</p></li>
      <li>
       <p>Verify that the <code>version</code> of each <code>import feature</code> in all <code>feature.xml</code> files is properly updated. The old version should no longer be present. This should be automatic.</p></li>
      <li>
       <p>Verify that the <code>Bundle-Version</code> of all <code>MANIFEST.MF</code> files in <code>org.eclipse.escet.*</code> projects are properly updated. The old version should no longer be present. This should be automatic.</p></li>
      <li>
       <p>Manually replace in all <code>MANIFEST.MF</code> files the regex <code>org\.eclipse\.escet\.([a-z0-9\.]+);bundle-version="&lt;old-version&gt;"</code> by <code>org.eclipse.escet.\1;bundle-version="&lt;new-version&gt;"</code>, where <code>&lt;old-version&gt;</code> and <code>&lt;new-version&gt;</code> are replaced by actual versions, e.g. <code>0.1.0</code>. Check for unintended changes. Search for the old version in all manifests to ensure none remain.</p></li>
      <li>
       <p>In all documentation sets, add a new section to the release notes for the new version, before the existing versions:</p>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-asciidoc hljs" data-lang="asciidoc">=== Version 0.2

TBD</code></pre>
        </div>
       </div></li>
      <li>
       <p>Verify that the <code>&lt;version&gt;</code> of a POM and its parent in each <code>pom.xml</code> are properly updated. The old version should no longer be present. This should mostly be automatic. Manually adapt it where necessary.</p></li>
      <li>
       <p>Verify that the <code>version</code> of all <code>feature.xml</code> files in <code>org.eclipse.escet.*</code> projects are properly updated. The old version should no longer be present. This should be automatic.</p></li>
      <li>
       <p>Verify that the <code>license-feature-version</code> of all <code>feature.xml</code> files in <code>org.eclipse.escet.*</code> projects are properly updated. The old version should no longer be present. This should be automatic.</p></li>
      <li>
       <p>Manually search for the old version in all <code>features.xml</code> files to ensure none remain.</p></li>
      <li>
       <p>Search the entire Git repository (all projects) for the old version number and update anything that still requires updating.</p></li>
      <li>
       <p>Test that the <a href="building-and-testing.html">build works</a>.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="working-on-a-release"><a class="anchor" href="#working-on-a-release"></a>Working on a release</h3>
    <div class="paragraph">
     <p>The work for the next release (milestone, release candidate, or final release) is done in the <code>develop</code> branch. See the <a href="development-process.html">development process</a> for more information.</p>
    </div>
    <div class="paragraph">
     <p>Note that for each version at least one milestone release and at least one release candidate are required before a final release.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="preparing-a-release"><a class="anchor" href="#preparing-a-release"></a>Preparing a release</h3>
    <div class="paragraph">
     <p>Once the work on <code>develop</code> is done for a release (milestone, release candidate, or final release), follow these steps to prepare for the release:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Double check that the release notes of all documentation sets have been updated for all end-user visible changes.</p></li>
      <li>
       <p>For a final release add the release date to the release notes.</p></li>
      <li>
       <p>For a final release ensure the <code>TBD</code> indication is removed in the release notes of all documentation sets.</p></li>
      <li>
       <p>For a final release ensure that all IP is accounted for and all relevant Eclipse Foundation IP team issues in <a href="https://gitlab.eclipse.org/eclipsefdn/emo-team/iplab">IPLab</a> have been approved by the Eclipse Foundation IP team.</p></li>
      <li>
       <p>For a final release ensure that a <a href="#preparing-a-progress-review">progress review</a> has been successfully completed no more than one year ago.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="preparing-a-progress-review"><a class="anchor" href="#preparing-a-progress-review"></a>Preparing a progress review</h3>
    <div class="paragraph">
     <p>For a final release a progress review (or release review) must have been successfully completed no more than one year ago. Follow these steps to prepare a progress review:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Read the <a href="https://www.eclipse.org/projects/handbook/#progress-review">official information on progress reviews</a> in the Eclipse Project Handbook.</p></li>
      <li>
       <p>The Eclipse Foundation now schedules a new progress review one year after the current one completes, by creating a corresponding GitLab issue in the EMO’s GitLab. So, there should be no need to schedule one ourselves. But, if the Eclipse Foundation did not schedule one, we should ask the EMO to schedule one:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Send an email to <code>emo@eclipse.org</code>, with a CC to <code>escet-dev@eclipse.org</code>.</p>
          <div class="ulist">
           <ul>
            <li>
             <p>As subject, use <code>Please schedule the yearly Eclipse ESCET progress review</code>.</p></li>
            <li>
             <p>As message, use the following template:</p>
             <div class="listingblock">
              <div class="content">
               <pre class="highlightjs highlight"><code class="language-none hljs">Please schedule the yearly Eclipse ESCET progress review.

Kind regards,
&lt;Your Name&gt;
Eclipse ESCET &lt;your role&gt;</code></pre>
              </div>
             </div>
             <div class="paragraph">
              <p>Replace <code>&lt;Your Name&gt;</code> by your full name (first and last name). Replace <code>&lt;your role</code>&gt; by either <code>project lead</code> or <code>project committer</code>.</p>
             </div></li>
           </ul>
          </div></li>
        </ul>
       </div></li>
      <li>
       <p>Create an Eclipse ESCET issue to track the progress review:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Give it the title <code>Eclipse ESCET progress review YYYY-MM-DD</code>, with <code>YYYY-MM-DD</code> the due date of the EMO’s GitLab issue.</p></li>
         <li>
          <p>As content, use the following template:</p>
          <div class="listingblock">
           <div class="content">
            <pre class="highlightjs highlight"><code class="language-none hljs">The EMO created a progress review for YYYY-MM-DD:
* https://projects.eclipse.org/projects/technology.escet/reviews/YYYY.MM-progress-review
* https://gitlab.eclipse.org/eclipsefdn/emo-team/emo/-/issues/NNN</code></pre>
           </div>
          </div>
          <div class="paragraph">
           <p>Replace <code>YYYY-MM-DD</code> by the due date of the EMO’s GitLab issue. Replace <code>YYYY.MM</code> by the due month of the EMO’s GitLab issue. Replace <code>NNN</code> by the EMO’s GitLab issue that tracks the progress review. Check that the links work correctly.</p>
          </div></li>
        </ul>
       </div></li>
      <li>
       <p>Request PMC approval two weeks in advance:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Go to <a href="https://accounts.eclipse.org/mailing-list/technology-pmc" class="bare">https://accounts.eclipse.org/mailing-list/technology-pmc</a> and subscribe to the Technology PMC mailing list, if not yet subscribed. Subscription is necessary to post to the list.</p></li>
         <li>
          <p>Send an email to <code>technology-pmc@eclipse.org</code>, with a CC to <code>escet-dev@eclipse.org</code>.</p>
          <div class="ulist">
           <ul>
            <li>
             <p>As subject, use <code>Request progress review approval for the Eclipse ESCET project</code>.</p></li>
            <li>
             <p>As message, use the following template:</p>
             <div class="listingblock">
              <div class="content">
               <pre class="highlightjs highlight"><code class="language-none hljs">The Eclipse ESCET project hereby requests approval for its annual progress review.

See https://gitlab.eclipse.org/eclipsefdn/emo-team/emo/-/issues/NNN

Kind regards,
&lt;Your Name&gt;
Eclipse ESCET &lt;your role&gt;</code></pre>
              </div>
             </div>
             <div class="paragraph">
              <p>Replace <code>NNN</code> by the EMO’s GitLab issue that tracks the progress review. Replace <code>&lt;Your Name&gt;</code> by your full name (first and last name). Replace <code>&lt;your role</code>&gt; by either <code>project lead</code> or <code>project committer</code>.</p>
             </div></li>
           </ul>
          </div></li>
        </ul>
       </div></li>
      <li>
       <p>Update the progress review issue description with the following template:</p>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-markdown hljs" data-lang="markdown">See the following pages for submitted materials and approval:
* PMC approval request: https://www.eclipse.org/lists/technology-pmc/msgNNN.html
* PMC approval: https://www.eclipse.org/lists/technology-pmc/msgNNNN.html</code></pre>
        </div>
       </div>
       <div class="paragraph">
        <p>Replace <code>NNN</code> and <code>NNNN</code> by the corresponding mailing list message numbers. Consult the <a href="http://www.eclipse.org/lists/technology-pmc">Technology PMC mailing list archive</a> to find the messages and their message numbers.</p>
       </div></li>
      <li>
       <p>Ensure the progress review is successful before <a href="#performing-a-release">performing the release</a>.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="performing-a-release"><a class="anchor" href="#performing-a-release"></a>Performing a release</h3>
    <div class="paragraph">
     <p>To perform a release (milestone, release candidate, or final release), i.e. actually release it, follow these steps:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Merge <code>develop</code> to <code>master</code>:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Since <code>master</code> is a protected branch for the Eclipse ESCET GitLab, a GitLab merge request is the only way to update it.</p></li>
         <li>
          <p>Create a GitLab merge request from <code>develop</code> to <code>master</code>.</p></li>
         <li>
          <p>For <em>Title</em> enter <code>#NNN develop to master for vN.N</code>. Replace <code>#NNN</code> by the relevant issue number. Replace <code>N.N</code> by the release version, e.g. <code>1.0-M1</code>, <code>1.0-RC1</code> or <code>1.0</code>.</p></li>
         <li>
          <p>Replace the automatically generated but incomplete <em>Description</em> by <code>Addresses #NNN</code>. Replace <code>#NNN</code> by the relevant issue number.</p></li>
         <li>
          <p>For <em>Milestone</em> select the relevant milestone.</p></li>
         <li>
          <p>For <em>Labels</em> select <em>RelEng/DevOps</em> and <em>Type::Enhancement</em>.</p></li>
         <li>
          <p>Click <em>Create merge request</em>.</p></li>
         <li>
          <p>Wait for the <a href="building-and-testing.html">builds on Jenkins</a> to successfully complete and press <em>Merge</em>. Alternatively, press <em>Merge when pipeline succeeds</em> to automatically merge the merge request once the build succeeds.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Add a tag on the commit in <code>master</code> that is to be released. Only version tags with a specific syntax will be picked up by Jenkins to be released. For instance, use <code>v0.1</code>, <code>v0.1.1</code>, <code>v2.0</code>, etc for releases, <code>v0.1-M1</code> for a milestone build, or <code>v0.1-RC1</code> for a release candidate.</p>
       <div class="paragraph">
        <p>Add the tag via GitLab, at <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/tags/new" class="bare">https://gitlab.eclipse.org/eclipse/escet/escet/-/tags/new</a>. Use the <em>Tag name</em> also as <em>Message</em>. Make sure to select <code>master</code> as branch from which to create the tag. Click <em>Create tag</em> to create the new tag.</p>
       </div></li>
      <li>
       <p>Add a GitLab release for the new tag, at <a href="https://gitlab.eclipse.org/eclipse/escet/escet/-/releases/new" class="bare">https://gitlab.eclipse.org/eclipse/escet/escet/-/releases/new</a>. Select the tag you just created under <em>Tag name</em>. Set the <em>Release title</em> and <em>Release notes</em> to the tag name. Select the relevant milestone under <em>Milestones</em>. Click <em>Create release</em> to create the new release.</p></li>
      <li>
       <p>Go to Jenkins, at <a href="https://ci.eclipse.org/escet/job/ESCET%20build/" class="bare">https://ci.eclipse.org/escet/job/ESCET%20build/</a>. Log in to Jenkins by clicking on the link at the top-right of the page. Select <em>Scan GitLab Project Now</em> to ensure Jenkins picks up the new tag.</p></li>
      <li>
       <p>Go to <a href="https://ci.eclipse.org/escet/job/ESCET%20build/view/tags/" class="bare">https://ci.eclipse.org/escet/job/ESCET%20build/view/tags/</a> to see the new tag on Jenkins. Manually trigger a build for the tag, by clicking the <em>Schedule a build for …​</em> icon in the row for the tag. Jenkins will then automatically build and release a new version from that tag.</p></li>
      <li>
       <p>All releases are available at <a href="https://download.eclipse.org/escet/" class="bare">https://download.eclipse.org/escet/</a>. For a version <code>v0.1</code>, the downloads will be located at <code>https://download.eclipse.org/escet/v0.1</code>.</p>
       <div class="ulist">
        <ul>
         <li>
          <p>End users should however be referred to <a href="https://eclipse.dev/escet/download.html" class="bare">https://eclipse.dev/escet/download.html</a> instead of <code>download.eclipse.org</code>. The buttons on this web page serve downloads via a mirror script. This ensures that a nearby mirror is selected, for faster downloads. It also ensures that downloads are counted in the download statistics. Furthermore, it transparently handles files moved from <code>download.eclipse.org</code> to <code>archive.eclipse.org</code>.</p></li>
         <li>
          <p>According to the Eclipse Foundation Wiki page <a href="https://gitlab.eclipse.org/eclipsefdn/helpdesk/-/wikis/IT_Infrastructure_Doc">IT Infrastructure Doc</a>, "Once your files are on the <code>download.eclipse.org</code> server, they are immediately available to the general public. However, for release builds, we ask that you wait at least four hours for our mirror sites to fetch the new files before linking to them. It typically takes a day or two for all the mirror sites to synchronize with us and get new files." Immediately after the downloads being available, downloading them may thus be slower, even if the mirror script is used.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Jenkins will automatically push the website for the new release to the website Git repository, in a directory for the specific release. For a version <code>v0.1</code>, the website can be accessed at <code>https://eclipse.dev/escet/v0.1</code>. It may take a few minutes for the <a href="https://gitlab.eclipse.org/eclipse/escet/escet-website/-/commits/master">new commit</a> to the Git repository to be synced to the webserver. It may take up to an hour for the website of the new version to become available, due to browser caches and the Eclipse Foundation webserver using a <code>max-age</code> of 3600 seconds for some files.</p></li>
      <li>
       <p>For a final release with a version number higher than that of the current standard visible website (at <code><a href="https://eclipse.dev/escet" class="bare">https://eclipse.dev/escet</a></code>), promote the newly released website to be the new standard visible website:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>These steps assume that you’ve set up an Eclipse ESCET development environment, using the <a href="dev-env-setup.html">standard instructions</a>, at <code>&lt;path-to-dev-env&gt;</code>.</p></li>
         <li>
          <p>Open a terminal.</p></li>
         <li>
          <p>Execute <code>cd &lt;path-to-dev-env&gt;/git</code> to go to the directory of your development environment with Git repositories.</p></li>
         <li>
          <p>Make a shallow clone of the Eclipse ESCET website Git repository by executing <code>git clone --depth 1 --no-tags <a href="https://gitlab.eclipse.org/eclipse/escet/escet-website.git" class="bare">https://gitlab.eclipse.org/eclipse/escet/escet-website.git</a></code>.</p></li>
         <li>
          <p>Execute <code>cd escet-website</code> to enter the directory that contains the new clone.</p></li>
         <li>
          <p>Execute <code>../escet/misc/website/switch-standard-visible-website.bash vN.N "Full Name" "some@example.com"</code>, with appropriate substitutions, to replace the standard visible website:</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Replace <code>vN.N</code> with the website release version that is to become the standard visible website, e.g., <code>v0.1</code>, <code>v1.0-M1</code> or <code>v1.1.0-RC1</code>.</p></li>
            <li>
             <p>Replace <code>Full Name</code> by your full name (first name and last name) as registered in your Eclipse Foundation account, e.g., <code>John Smith</code>.</p></li>
            <li>
             <p>Replace <code>some@example.com</code> by your email address as registered in your Eclipse Foundation account.</p></li>
           </ul>
          </div></li>
         <li>
          <p>As indicated, review the new commit. If it is OK, push it by executing <code>git push</code>.</p></li>
         <li>
          <p>Check that the changes are correctly registered by GitLab, at <a href="https://gitlab.eclipse.org/eclipse/escet/escet-website/-/commits/master" class="bare">https://gitlab.eclipse.org/eclipse/escet/escet-website/-/commits/master</a>.</p></li>
         <li>
          <p>Remove the website repository clone, by executing <code>cd ..</code> and <code>rm -rf escet-website</code>.</p></li>
         <li>
          <p>It may take a few minutes for the Git repository to be synced to the webserver. The standard visible website can be accessed at <code><a href="https://eclipse.dev/escet" class="bare">https://eclipse.dev/escet</a></code>. It may take up to an hour for the website of the new version to become available, due to browser caches and the Eclipse Foundation webserver using a <code>max-age</code> of 3600 seconds for some files.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Since we can’t ask our end users to force refresh every webpage, nor to clear their browser’s cache, wait an hour and five minutes before proceeding with the next step.</p></li>
      <li>
       <p>Inform others about the new release:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>In the relevant GitLab issue, for final releases, post the following comment, where <code>N.N</code> is to be replaced by the actual release version, e.g. <code>0.1</code> or <code>1.0</code>:</p>
          <div class="listingblock">
           <div class="content">
            <pre class="highlightjs highlight"><code class="language-markdown hljs" data-lang="markdown">I just released vN.N:

- https://eclipse.dev/escet/
- https://eclipse.dev/escet/download.html
- https://eclipse.dev/escet/release-notes.html

And here are the permalinks:

- https://eclipse.dev/escet/vN.N
- https://eclipse.dev/escet/vN.N/download.html
- https://eclipse.dev/escet/vN.N/release-notes.html

Note that mirrors may still need to sync, so downloads may be a bit slower until then.</code></pre>
           </div>
          </div></li>
         <li>
          <p>In the relevant GitLab issue, for milestones and release candidates, post the following comment, where <code>N.N-NNN</code> is to be replaced by the actual release version, e.g. <code>0.1-M1</code> or <code>1.0-RC1</code>:</p>
          <div class="listingblock">
           <div class="content">
            <pre class="highlightjs highlight"><code class="language-markdown hljs" data-lang="markdown">I just released vN.N-NNN:

- https://eclipse.dev/escet/vN.N-NNN
- https://eclipse.dev/escet/vN.N-NNN/download.html
- https://eclipse.dev/escet/vN.N-NNN/release-notes.html

Note that mirrors may still need to sync, so downloads may be a bit slower until then.</code></pre>
           </div>
          </div></li>
         <li>
          <p>Also send an email to <code>escet-dev@eclipse.org</code> with similar content.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Clean up after the release:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Close the GitLab issue for the release.</p></li>
         <li>
          <p>For a final release, ensure all issues in the GitLab milestone are closed.</p></li>
         <li>
          <p>For a final release, close the GitLab milestone.</p></li>
        </ul>
       </div></li>
      <li>
       <p><a href="#removing-archiving-old-releases">Remove/archive</a> old releases.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="removing-archiving-old-releases"><a class="anchor" href="#removing-archiving-old-releases"></a>Removing/archiving old releases</h3>
    <div class="paragraph">
     <p>To prevent unnecessary disk space usage, old releases can be archived and removed. Below the policy and steps for both of them are explained. These steps are to be followed after <a href="#performing-a-release">performing a release</a>.</p>
    </div>
    <div class="paragraph">
     <p>For every release, including milestones and release candidates:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Remove the builds for all previously built tags, thus excluding the tag of the release that was just built:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>In Jenkins, while logged in, go to <a href="https://ci.eclipse.org/escet/job/ESCET%20build/view/tags/" class="bare">https://ci.eclipse.org/escet/job/ESCET%20build/view/tags/</a>.</p></li>
         <li>
          <p>Select the tag name in the <em>Name</em> column to go the tag’s page.</p></li>
         <li>
          <p>There, on the left, the various builds are indicated by <code>#n</code>, with <code>n</code> some number.</p></li>
         <li>
          <p>In the drop down menu of a build, select <em>Delete build #n</em> to remove it.</p></li>
         <li>
          <p>When asked to confirm, click <em>Yes</em>.</p></li>
        </ul>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>For every final release, thus excluding milestones and release candidates:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>Identify the milestone and release candidate versions to remove. We remove all milestones and release candidates of the previous version and older. E.g. for <code>v0.2</code>, we remove <code>v0.1-M1</code>, <code>v0.1-M2</code>, <code>v0.1-RC1</code>, etc.</p></li>
      <li>
       <p>Identify the final release versions to archive. We archive all releases older than the current and previous release, but never remove them. E.g. for <code>v0.3</code> we archive <code>v0.1</code> and older, but keep <code>v0.2</code>.</p></li>
      <li>
       <p>Remove the websites of the identified milestone and release candidate versions:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>These steps assume that you’ve set up an Eclipse ESCET development environment, using the <a href="dev-env-setup.html">standard instructions</a>, at <code>&lt;path-to-dev-env&gt;</code>.</p></li>
         <li>
          <p>Open a terminal.</p></li>
         <li>
          <p>Execute <code>cd &lt;path-to-dev-env&gt;/git</code> to go to the directory of your development environment with Git repositories.</p></li>
         <li>
          <p>Make a shallow clone of the Eclipse ESCET website Git repository by executing <code>git clone --depth 1 --no-tags <a href="https://gitlab.eclipse.org/eclipse/escet/escet-website.git" class="bare">https://gitlab.eclipse.org/eclipse/escet/escet-website.git</a></code>.</p></li>
         <li>
          <p>Execute <code>cd escet-website</code> to enter the directory that contains the new clone.</p></li>
         <li>
          <p>For each website version to remove:</p>
          <div class="ulist">
           <ul>
            <li>
             <p>Execute <code>../escet/misc/website/remove-website-version.bash vN.N "Full Name" "some@example.com"</code>, with appropriate substitutions, to remove the website:</p>
             <div class="ulist">
              <ul>
               <li>
                <p>Replace <code>vN.N</code> with the website milestone or release candidate version to remove, e.g.,<code>v0.9-M1</code> or <code>v1.1.0-RC1</code>.</p></li>
               <li>
                <p>Replace <code>Full Name</code> by your full name (first name and last name) as registered in your Eclipse Foundation account, e.g., <code>John Smith</code>.</p></li>
               <li>
                <p>Replace <code>some@example.com</code> by your email address as registered in your Eclipse Foundation account.</p></li>
              </ul>
             </div></li>
            <li>
             <p>As indicated, review the new commit. If it is OK, push it by executing <code>git push</code>.</p></li>
           </ul>
          </div></li>
         <li>
          <p>If successful you should see the changes on GitLab, at <a href="https://gitlab.eclipse.org/eclipse/escet/escet-website/-/commits/master" class="bare">https://gitlab.eclipse.org/eclipse/escet/escet-website/-/commits/master</a>.</p></li>
         <li>
          <p>Remove the website repository clone, by executing <code>cd ..</code> and <code>rm -rf escet-website</code>.</p></li>
         <li>
          <p>It may take a few minutes for the Git repository to be synced to the webserver, and for the removed websites to no longer be available online. Depending on browser cache settings and other factors, it may be necessary to force refresh your browser for it to pick up the changes on the server.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Remove the downloads of the identified milestone and release candidate versions:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Go to <a href="https://download.eclipse.org/escet/" class="bare">https://download.eclipse.org/escet/</a>.</p></li>
         <li>
          <p>Make sure you are logged in. This should make check-boxes appear.</p></li>
         <li>
          <p>Select the folders to archive (before subsequent removal) and click the <em>Move selected to archive.eclipse.org</em> button. It may take a few minutes for archiving to complete.</p></li>
         <li>
          <p>Go to <a href="https://archive.eclipse.org/escet/" class="bare">https://archive.eclipse.org/escet/</a>.</p></li>
         <li>
          <p>Make sure you are (still) logged in. This should make check-boxes appear.</p></li>
         <li>
          <p>Select the folders to delete and click the <em>Delete selected permanently</em> button. It may take a few minutes for deleting to complete.</p></li>
        </ul>
       </div></li>
      <li>
       <p>Archive the downloads of the identified final versions:</p>
       <div class="ulist">
        <ul>
         <li>
          <p>Note that links to <code>download.eclipse.org</code> transparently redirect to <code>archive.eclipse.org</code> for archived files. We can therefore safely archive final versions, without breaking links to update sites that use <code>download.eclipse.org</code>.</p></li>
         <li>
          <p>Go to <a href="https://download.eclipse.org/escet/" class="bare">https://download.eclipse.org/escet/</a>.</p></li>
         <li>
          <p>Make sure you are logged in. This should make check-boxes appear.</p></li>
         <li>
          <p>Select the folders to archive and click the <em>Move selected to archive.eclipse.org</em> button. It may take a few minutes for archiving to complete.</p></li>
         <li>
          <p>Do not remove final versions. They should be kept forever.</p></li>
        </ul>
       </div></li>
     </ul>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/plcst.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Eclipse ESCET™ development documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v6.0-RC1</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>